<?php


/*
 * Copyright 2005 Sebastian Siedentopf (openmail+sourcecode@siezi.com)
 */

include_once ("$FarmD/cookbook/itunes/itunescontrol.php");

$DefaultPageTextFmt = '';
$iTASDiv = '###';

Markup('iTunes', '<title', '/\\(:itunes:\\)/e', "iTunes()");

function iTunes() {
	global $playlist;

	$playlist 	= $_REQUEST['playlist'];
	$action 		= $_REQUEST['action'];
	$artist 		= $_REQUEST['artist'];
	$album 		= $_REQUEST['album'];
	$kind 		= $_REQUEST['kind'];
	$searchterm 	= $_REQUEST['q'];   
	
	$$kind 		= $searchterm;
	if ($action == 'itsearch') return ListTitel(1, $album, $artist, TRUE, $searchterm);
	
	if (!$playlist && $action != 'itshowsong')	return ListAllLibrarySources();
	if ($action === 'itcontrol') iTunesControl();
	if ($action === 'itplay') return iTunesPlaySong($playlist, $_REQUEST['index']);	
	if ($action === 'itshowsong') return iTunesShowSong($playlist, $_REQUEST['index']);	
	if ($artist === 'all')
		return ListPlaylistBy($playlist, 'artist');
	if ($album === 'all')
		return ListPlaylistBy($playlist, 'album');
	return ListTitel($playlist, $album, $artist);

}


function ListPlaylistBy($playlist, $kind) {
	global $pagename, $PageUrl, $iTASDiv;
	$name = ASPlaylistName($playlist);
	$items = trim(shell_exec("osascript <<EOF 
		tell application \"iTunes\"
			set AppleScript's text item delimiters to \"$iTASDiv\"
			set myTrack to (get $kind of tracks of playlist ".$playlist.") as string
		end tell
		return myTrack"));
	$items = explode($iTASDiv, $items);
	$items = array_unique($items);
	asort($items);
	$out[] = "Playlist $name; Get <a href='$PageUrl?playlist=$playlist'>All Title</a>";
	$out[] = "";
	foreach ($items as $key => $item) {
		$out[] = "- <a href='\$PageUrl/?playlist=$playlist&amp;$kind=".$item."'>$item</a>";
	}
	return Keep(FmtPageName(implode("<br />", $out), $pagename));
}

function ListAllLibrarySources() {
	global $PageUrl,$iTASDiv;
	$itparam = array ('title' => 'name', 'index' => 'index');
	foreach ($itparam as $paramname => $param) {
	$playlists[$paramname] = shell_exec("osascript <<EOF 
				tell application \"iTunes\"
		set AppleScript's text item delimiters to \"$iTASDiv\"
		set myPlaylist to (get $param of playlists) as string
		return myPlaylist
		end tell");
	}
	foreach ($itparam as $paramname => $param) 
		$playlists[$paramname] = explode($iTASDiv, $playlists[$paramname]);
	$out[] = "<table id='itsourcelist'>";
 	foreach ($playlists['title'] as $k => $item) {
		$class = $k%2;
		$out[] = "<tr class='tr$class'><td><a href='$PageUrl?playlist=".$playlists['index'][$k]."'>".$item."</a> </td><td> <a href='$PageUrl?playlist=".$playlists['index'][$k]."&amp;artist=all'>Artists</a> </td><td> <a href='$PageUrl?playlist=".$playlists['index'][$k]."&amp;album=all'>Albums</a> </td></tr>";
	}
	$out[] ="</table>";
	return Keep(implode("", $out));
}

function ListTitel($playlist, $album = NULL, $artist = NULL, $Search = FALSE, $searchterm = NULL) {
	global $ScriptUrl, $PageUrl, $pagename, $iTASDiv;
	$itparam = array ('title' => 'name', 'artist' => 'artist', 'album' => 'album', 'index' => 'database ID');
	$name = ASPlaylistName($playlist);
	if ($artist == NULL && $album == NULL) {
		foreach ($itparam as $paramname => $param) {
			$titles[$paramname] = shell_exec("osascript <<EOF
							set AppleScript's text item delimiters to \"$iTASDiv\" 
							tell application \"iTunes\"
								set myTrack to (get $param of tracks of playlist ".$playlist.")
							end tell
							set myTrack to myTrack as string
							return myTrack");
		}
		$headernavigation = "Playlist -> $name; "."(<a href='$PageUrl?playlist=$playlist&amp;artist=all'>Artists</a>) "."(<a href='$PageUrl?playlist=$playlist&amp;album=all'>Albums</a>)";
	}
	elseif ($Search = TRUE) {
		if (isset($artist)){
			$ascommand = "\"$artist\" only artists";
			$headernavigation = "Search results for artist: $artist";	
		} elseif (isset($album)) {
			$ascommand = "\"$album\" only albums";
			$headernavigation = "Search results for album: $album";	
		} elseif (isset($searchterm)) {
			$ascommand = $searchterm;
			$headernavigation = "Search results for: $searchterm";	
		}
		else
			return 'Fehler in ListTitel($Search=TRUE)';
		
		foreach ($itparam as $paramname => $param) {
			$titles[$paramname] = trim(shell_exec("osascript <<EOF 
				set AppleScript's text item delimiters to \"$iTASDiv\"
				tell application \"iTunes\"
				tell playlist $playlist
					set mySearch to search for $ascommand
				end tell
				set myTracks to {}
				repeat with aTrack in mySearch
					set myTracks to myTracks & (get $param of aTrack)
				end repeat
				end tell
				set myTracks to myTracks as string
				return myTracks"));
		}

	} else {

		if (isset ($artist)) {
			$ascommand = "artist is \"$artist\"";
			$headerstring = "Songs by $artist";
		}
		elseif (isset ($album)) {
			$ascommand = "album is \"$album\"";
			$headerstring = "Songs on $album";
		}

		foreach ($itparam as $paramname => $param) {
			$titles[$paramname] = shell_exec("osascript <<EOF
							set AppleScript's text item delimiters to \"$iTASDiv\" 
							tell application \"iTunes\" 
							tell playlist $playlist
								set myTrack to $param of (every track whose $ascommand) as string
							end tell
							end tell
							set myTrack to myTrack as string
							return myTrack");
		}
		$headernavigation = "Playlist -> $name; $headerstring (<a href='$PageUrl?playlist=$playlist'>Show all Songs</a>)";
	}

	foreach ($itparam as $paramname => $param)
		$titles[$paramname] = explode($iTASDiv, $titles[$paramname]);

	$out[] = $headernavigation;
	$out[] = "<br /><table id='ittitlelist'>";
	foreach ($titles['title'] as $key => $item) {
		$i = $key+1;
		$class = $key%2;
		$out[] = "<tr class='tr$class' ><td >$i</td><td><a href='$PageUrl?action=itplay&amp;index=".$titles['index'][$key]."&amp;playlist=".$playlist."'>$item</a></td>"."<td><a href='$PageUrl?action=itsearch&amp;playlist=$playlist&amp;artist=".$titles['artist'][$key]."'>".$titles['artist'][$key]."</a></td>
					 <td><a href='$PageUrl?action=itsearch&amp;playlist=$playlist&amp;album=".$titles['album'][$key]."'>".$titles['album'][$key]."</a></td></tr>";
	}
	$out[] = "</table>";
	return Keep(FmtPageName(implode("", $out), $pagename));
}

function iTunesPlaySong($playlist, $index) {
	global $FarmD, $PubDirUrl, $PageUrl;

	shell_exec("osascript <<EOF 
		tell application \"iTunes\"
			set myPlaylist to playlist $playlist
			set view of front window to myPlaylist
			tell playlist $playlist
				set the_track to name of (every track whose database ID is $index) as string
				play track the_track
			end tell
		end tell");

		return iTunesShowSong($playlist,$index);	
}

function iTunesShowSong($playlist, $index) {
	global $FarmD, $PubDirUrl, $PageUrl;
	
	if (!isset($index))
		$index = trim(shell_exec("osascript <<EOF 
		tell application \"iTunes\"
			set currentTrack to database ID of current track
		end tell
		return currentTrack"));
	if (!isset($playlist)) $playlist = 1;
		
	#$HTMLHeaderFmt['itrefresh'] = "<meta http-equiv='refresh' content='10'>";
	
	$itparam = array ('artist' => 'artist', 'album' => 'album');
	$_REQUEST['action'] = 'itshowsong';
	
	shell_exec("rm $FarmD/pub/itcovertmp.jpg");
	
	$title = trim(shell_exec("osascript <<EOF 
		tell application \"iTunes\"
			set myPlaylist to playlist $playlist
			set view of front window to myPlaylist
			tell playlist $playlist
				set the_track to name of (every track whose database ID is $index) as string
			end tell
		end tell
		return the_track"));

	foreach ($itparam as $paramname => $param) {
	$$paramname = shell_exec("osascript <<EOF 
		tell application \"iTunes\"
			tell playlist $playlist
				set the_track to $param of track \"$title\"
				return the_track
			end tell
		end tell");
	}

	shell_exec("osascript <<EOF 
		set p to \"/$FarmD/pub/\"
		set a to POSIX file p
		tell application \"iTunes\"
		tell playlist $playlist
			set theFile to ((a as string) & \"itcovertmp.jpg\") as file specification
			set the_track to track \"$title\"
			set theData to (data of artwork 1 of the_track)
			set theJPEG to giconvert (theData) type \"JPEG\" image theFile
	 resolution {72, 72} 
		end tell
		end tell");

	$out[] = "Playlist -> <a href='$PageUrl?playlist=$playlist'>".ASPlaylistName($playlist)."</a>
			 (<a href='$PageUrl?action=playlist=$playlist&amp;artist=$artist'>$artist</a>) (<a href='$PageUrl?playlist=$playlist&amp;album=$album'>$album</a>) <br/><br/>";
	if (file_exists("$FarmD/pub/itcovertmp.jpg"))
		$out[] = "<img  src='$PubDirUrl/itcovertmp.jpg' style='width:120px;float:right;'/>";
	$out [] = "<table>";
	$out[] = "<tr><td><strong>Title</strong>: $title </td></tr><tr><td><strong>Artist</strong>: $artist </td></tr><tr><td><strong>Album:</strong> $album </td></tr>";
	$out[] = "</table>";
	return Keep(implode("", $out));
}

function iTunesControl() {
	global $pagename;
	$command = $_REQUEST['command'];
	if ($command === "volume") {
		$command = "set theVolume to the sound volume
					set sound volume to theVolume ".$_REQUEST['uod']." ".$_REQUEST['value'];
	}
	shell_exec("osascript <<EOF 
				tell application \"iTunes\"
					$command
				end tell");
	$_REQUEST['action'] = $_REQUEST['oldaction'];
}

function ASPlaylistName($playlist) {
	return trim(shell_exec("osascript <<EOF 
			tell application \"iTunes\"
				set PlaylistName to name of playlist ".$playlist."
				return PlaylistName
			end tell"));
}
?>
